new;
library gdr,pgraph;
gdrSet;

u1 = seqa(0.001,0.001,9)|seqa(0.01,0.98/5000,5001)|seqa(0.991,0.001,9);
u2 = SingularCopulaLower2(u1)~
     SingularCopulaUpper2(u1)~
     SingularCopulaMarshallOlkin(u1,0.5,0.75);
n1 = cdfni(u1); n2 = cdfni(u2);
t1 = cdftci(1-u1,3); t2 = cdftci(1-u2,3);
s1 = invSingularDistribution(u1);
s2a = invSingularDistribution(SingularCopulaLower2(u1));
s2b = invSingularDistribution(SingularCopulaUpper2(u1));
s2c = invSingularDistribution(SingularCopulaMarshallOlkin(u1,0.5,0.75));

{s1a,s2a} = split(s1,s2a);
{s1b,s2b} = split(s1,s2b);
{s1c,s2c} = split(s1,s2c);

graphset;
  begwind;
  window(2,2,1);

  _pdate = ""; _pframe = 0; _pcross = 1; _pnum = 2;
  _plwidth = 10; _pltype = 3|1|6; _paxht = 0.30; _pnumht = 0.20; _pcolor = 4|1|2;
  fonts("simplex simgrma");
  xtics(-0.2,1.2,0.2,0); ytics(-0.2,1.2,0.2,0);
  let xlab = "" "0" "0.2" "0.4" "0.6" "0.8" "1";  
  asclabel(xlab,xlab);

  setwind(1);
    xlabel("\216u]1["); 
    ylabel("\216u]2[");
    _pline = 1~6~0~1~1~1~1~0~10 |
             1~6~1~0~1~1~1~0~10 |
             1~6~0~0~1~0~1~0~10 |
             1~6~0~0~0~1~1~0~10 |
             1~3~0.25~0~0.25~1~1~0~6 |
             1~3~0.75~0~0.75~1~1~0~6 |
             1~3~0~0.25~1~0.25~1~0~6 |
             1~3~0~0.75~1~0.75~1~0~6 ;
    xy(u1,u2);

  setwind(4);
    xlabel("\216\202\120\201]1["); 
    ylabel("\216\202\120\201]2[");
    _pmsgstr = "(a)\000(b)\000(c)";
    _pmsgctl = {0.05 0.20 0.15 0 1 0 6,
                0.12 0.80 0.15 0 1 0 6,
                0.80 0.92 0.15 0 1 0 6};
    _pltype = 3; _pcolor = 4; xy(s1a,s2a);
    _pltype = 1; _pcolor = 1; xy(s1b,s2b);
    _pltype = 6; _pcolor = 2; xy(s1c,s2c);

  graphset;
    _pcross = 0; _pframe = 0; _pnum = 2;
    _paxht = 0.30; _pnumht = 0.20; _pltype = 3|1|6;
    _pcross = 1; _plwidth = 10; _pcolor = 4|1|2;

  setwind(2);
    xlabel("\216x]1[");  
    ylabel("\216y]2[");
    xy(n1,t2);

  setwind(3);
    _plegstr = "C[-]\000C[+]\000Marshall-Olkin";
    _plegctl = {2 6 6.5 5.75};
    xlabel("\216y]1["); 
    ylabel("\216y]2[");
    xy(t1,t2);

    graphprt("-c=1 -cf=sklar13.eps");
  endwind;

  
