new;
library gdr,optmum,pgraph;

#include param1.mkt;

cls;

zcTable[.,1] = zcTable[.,1]/365;
let lambdaTable[1,2] = 1 0;

let Maturity = 0.5  1   2   3   5   7   10;
let Spread =   60   55  50  45  40  35  30; 
Spread = Spread / 1e4;
nCDS = rows(Spread);
Tm = CDS_Make_TmTable(Maturity);

Nominal = 1e6;
Recovery = 0.40;

_opgtol = 1e-10;

sv = 0.10;
lambdaTable = Maturity~sv*ones(rows(Maturity),1);
lambdaTable = CDS_Calibrate_Lambda(zcTable,lambdaTable,Nominal,Recovery,Spread,Maturity,Tm);

CDS = zeros(nCDS,1);
ATM = zeros(nCDS,1);
i = 1;
do until i > nCDS;
  Tm = seqa(0.25,0.25,4*Maturity[i]);
  {CDS[i],ATM[i]} = CDS_Pricing(zcTable,lambdaTable,Nominal,Recovery,Spread[i],Maturity[i],Tm);
  i = i + 1;
endo;
ATM = 1e4*ATM;

output file = credit16.out reset;

print ftosa(1e4*LambdaTable[.,2],"%lf",4,1)$~ftosa(1e4*Spread~ATM,"%lf",4,1);

output off;

